#include "mutex.h"

#include <pthread.h>
#include <string.h>

/***** Quick'n'dirty mutex stuff *****/


void _al_mutex_lock(_AL_MUTEX *mutex)
{
   if(mutex)
   {
      pthread_t self = pthread_self();
      if(mutex->count == 0 || memcmp(&mutex->self, &self, sizeof(self)) != 0)
      {
            pthread_mutex_lock(&mutex->mutex);
            mutex->self = pthread_self();
      }
      mutex->count++;
   }
}

void _al_mutex_unlock(_AL_MUTEX *mutex)
{
   if(mutex && --(mutex->count) == 0)
      pthread_mutex_unlock(&mutex->mutex);
}

void _al_mutex_init(_AL_MUTEX *mutex)
{
   mutex->count = 0;
   pthread_mutex_init(&mutex->mutex, NULL);
}

void _al_mutex_deinit(_AL_MUTEX *mutex)
{
   if(mutex->count > 0)
   {
      mutex->count = 0;
      pthread_mutex_unlock(&mutex->mutex);
   }
   pthread_mutex_destroy(&mutex->mutex);
}
